IncludeObject (Apache FOP Core 2.11 API)
Date: 2025-04-24

org.apache.fop.afp.modca

## Class IncludeObject

- java.lang.Object
- - org.apache.fop.afp.modca.AbstractAFPObject
  - - org.apache.fop.afp.modca.AbstractStructuredObject
    - - org.apache.fop.afp.modca.AbstractTripletStructuredObject
      - - org.apache.fop.afp.modca.AbstractNamedAFPObject
        - - org.apache.fop.afp.modca.IncludeObject

- All Implemented Interfaces:
    Streamable

      public class IncludeObject
      extends AbstractNamedAFPObject

  An Include Object structured field references an object on a page or overlay. It optionally contains parameters that identify the object and that specify presentation parameters such as object position, size, orientation, mapping, and default color.

  Where the presentation parameters conflict with parameters specified in the object's environment group (OEG), the parameters in the Include Object structured field override. If the referenced object is a page segment, the IOB parameters override the corresponding environment group parameters on all data objects in the page segment.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.fop.afp.modca.AbstractAFPObject

      `AbstractAFPObject.Category, AbstractAFPObject.Type`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static byte` | `TYPE_BARCODE` the object referenced is of type barcode
    `static byte` | `TYPE_GRAPHIC` the object referenced is of type graphic
    `static byte` | `TYPE_IMAGE` the object referenced is of type image
    `static byte` | `TYPE_OTHER` the object referenced is of type other
    `static byte` | `TYPE_PAGE_SEGMENT` the object referenced is of type page segment

    - ### Fields inherited from class org.apache.fop.afp.modca.AbstractNamedAFPObject

      `name`

    - ### Fields inherited from class org.apache.fop.afp.modca.AbstractTripletStructuredObject

      `triplets`

    - ### Fields inherited from class org.apache.fop.afp.modca.AbstractAFPObject

      `LOG, SF_CLASS, SF_HEADER_LENGTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IncludeObject(String name)` Constructor for the include object with the specified name, the name must be a fixed length of eight characters and is the name of the referenced object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `setContentAreaOffset(int x, int y)` Sets the x and y offset of the content area to the object area used in conjunction with the `MappingOptionTriplet.POSITION` and `MappingOptionTriplet.POSITION_AND_TRIM`.
    `void` | `setMappingOption(byte optionValue)` Sets the mapping option
    `void` | `setMeasurementUnits(int xRes, int yRes)` Sets the measurement units used to specify the units of measure
    `void` | `setObjectAreaOffset(int x, int y)` Sets the x and y offset to the origin in the object area
    `void` | `setObjectAreaOrientation(int orientation)` Sets the orientation to use for the Include Object.
    `void` | `setObjectAreaSize(int x, int y)` Sets the extent of an object area in the X and Y directions
    `void` | `setObjectType(byte type)` Sets the data object type
    `String` | `toString()`
    `void` | `writeToStream(OutputStream os)` DataStream objects must implement the writeToStream() method to write its data to the given OutputStream

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractNamedAFPObject

      `copySF, getName, getNameBytes, getNameLength, setName`

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractTripletStructuredObject

      `addTriplet, addTriplets, getFullyQualifiedName, getTripletDataLength, getTriplets, hasTriplet, hasTriplets, setComment, setFullyQualifiedName, setFullyQualifiedName, setObjectClassification, writeTriplets`

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractStructuredObject

      `writeContent, writeEnd, writeStart`

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractAFPObject

      `copySF, truncate, writeChunksToStream, writeObjects`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### TYPE_PAGE_SEGMENT

          public static final byte TYPE_PAGE_SEGMENT

      the object referenced is of type page segment
      See Also:
        Constant Field Values

    - #### TYPE_OTHER

          public static final byte TYPE_OTHER

      the object referenced is of type other
      See Also:
        Constant Field Values

    - #### TYPE_GRAPHIC

          public static final byte TYPE_GRAPHIC

      the object referenced is of type graphic
      See Also:
        Constant Field Values

    - #### TYPE_BARCODE

          public static final byte TYPE_BARCODE

      the object referenced is of type barcode
      See Also:
        Constant Field Values

    - #### TYPE_IMAGE

          public static final byte TYPE_IMAGE

      the object referenced is of type image
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### IncludeObject

          public IncludeObject(String name)

      Constructor for the include object with the specified name, the name must be a fixed length of eight characters and is the name of the referenced object.
      Parameters:
        `name` - the name of this include object

  - ### Method Detail

    - #### setObjectAreaOrientation

          public void setObjectAreaOrientation(int orientation)

      Sets the orientation to use for the Include Object.
      Parameters:
        `orientation` - The orientation (0,90, 180, 270)

    - #### setObjectAreaOffset

          public void setObjectAreaOffset(int x,
                                          int y)

      Sets the x and y offset to the origin in the object area
      Parameters:
        `x` - the X-axis origin of the object area
        `y` - the Y-axis origin of the object area

    - #### setContentAreaOffset

          public void setContentAreaOffset(int x,
                                           int y)

      Sets the x and y offset of the content area to the object area used in conjunction with the `MappingOptionTriplet.POSITION` and `MappingOptionTriplet.POSITION_AND_TRIM`.
      Parameters:
        `x` - the X-axis origin defined in the object
        `y` - the Y-axis origin defined in the object

    - #### setObjectType

          public void setObjectType(byte type)

      Sets the data object type
      Parameters:
        `type` - the data object type

    - #### writeToStream

          public void writeToStream(OutputStream os)
                             throws IOException

      DataStream objects must implement the writeToStream() method to write its data to the given OutputStream
      Specified by:
        `writeToStream` in interface `Streamable`
      Overrides:
        `writeToStream` in class `AbstractStructuredObject`
      Parameters:
        `os` - the outputsteam stream
      Throws:
        `IOException` - an I/O exception of some sort has occurred.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractNamedAFPObject`

    - #### setMappingOption

          public void setMappingOption(byte optionValue)

      Sets the mapping option
      Parameters:
        `optionValue` - the mapping option value

    - #### setObjectAreaSize

          public void setObjectAreaSize(int x,
                                        int y)

      Sets the extent of an object area in the X and Y directions
      Parameters:
        `x` - the x direction extent
        `y` - the y direction extent

    - #### setMeasurementUnits

          public void setMeasurementUnits(int xRes,
                                          int yRes)

      Sets the measurement units used to specify the units of measure
      Parameters:
        `xRes` - units per base on the x-axis
        `yRes` - units per base on the y-axis

Copyright © 2025 Apache Software Foundation. All rights reserved.